unit KalmanFilteringDemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, KalmanFiltering, TeEngine, Series, ExtCtrls, TeeProcs, Chart, Math,
  Db, DBTables;
const
  szStreet=200;
type
  TfrmKalmanFilteringDemo = class(TForm)
    kf: TKalmanFiltering;
    Button2: TButton;
    FilterExp: TEdit;
    Clear: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Truth: TLabel;
    Priori: TLabel;
    Posteriori: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    NumberItem: TLabel;
    Button3: TButton;
    Teaching: TEdit;
    Noise: TCheckBox;
    BtnPolynomial: TButton;
    ListPosteriori: TListBox;
    ListPriori: TListBox;
    Label6: TLabel;
    Label7: TLabel;
    Recursive: TRadioButton;
    Movingaverage: TRadioButton;
    Mode: TGroupBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label8: TLabel;
    Memo1: TMemo;
    
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure kfNextPrioriEstimation(Sender: TObject; Estimation: Double);
    procedure kfNextPosterioriEstimation(Sender: TObject; Estimation: Double);
    procedure kfNextItem(Sender: TObject; Value: Double);
    procedure Button3Click(Sender: TObject);
    procedure BtnPolynomialClick(Sender: TObject);
    procedure RecursiveClick(Sender: TObject);
    procedure MovingaverageClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
    Counter: Int64;
    FlagN: boolean;
  public
    { Public declarations }
  end;

var
  frmKalmanFilteringDemo: TfrmKalmanFilteringDemo;

implementation

{$R *.DFM}


procedure TfrmKalmanFilteringDemo.Button2Click(Sender: TObject);
var
  xValue: double;
  xNoise: double;
begin
      if FlagN  then
        xNoise := 1
      else
        xNoise := 0;
      //xValue := 2 + 9* Counter * Counter + Counter * Counter * Counter; // Counter + Random * 200;//*i*i*i;// - 7*i*i*i*i;
      xValue := 50 * sin(2 * Pi * Counter / szStreet ){+ 10 * sin(2 * Pi * 10 * Counter / szStreet )} + xNoise * Random * 20;
      NumberItem.Caption := IntToStr(Counter);
      kf.AddInputDataItem(xValue);
      Inc(Counter);
end;

///////////////////////
//   //
///////////////////////
procedure TfrmKalmanFilteringDemo.FormActivate(Sender: TObject);
var
  i: integer;
begin
  FilterExp.Text := IntToStr(kf.FilterExponent);
  Teaching.Text := IntToStr(kf.SizeTeachingSequence);

  if kf.Mode = mdRecursive then
    Recursive.Checked := true
  else
    Movingaverage.Checked := true;
end;

////////////////////////////
//   "Clear"  //
////////////////////////////
procedure TfrmKalmanFilteringDemo.ClearClick(Sender: TObject);
var
  i: Integer;
begin
  kf.ClearFilter;
  i := StrToInt(FilterExp.Text);
  if i > 10 then
    begin
      kf.FilterExponent := 10;
      FilterExp.Text := IntToStr(10);
    end
  else if i < 0 then
         begin
           kf.FilterExponent := 0;
           FilterExp.Text := IntToStr(0);
         end
       else
         kf.FilterExponent := i;
  kf.SizeTeachingSequence := StrToInt(Teaching.Text);

  if kf.Mode = mdRecursive then
    Recursive.Checked := true
  else
    Movingaverage.Checked := true;
  if Noise.Checked  then
    FlagN := boolean(1)
  else
    FlagN := false;
  Counter := 0;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Truth.Caption := '';
  Posteriori.Caption := '';
  Priori.Caption := '';
  NumberItem.Caption := '';
  for i := 0 to kf.FilterExponent do
    begin
      Series2.Add(0,'',clRed);
      if i >0 then
       Series3.Add(0,'',clGreen);
    end;

  if kf.Mode = mdMovingaverage then
    for i := 0 to kf.SizeTeachingSequence  do
      begin
        Series2.Add(0,'',clRed);
        Series3.Add(0,'',clGreen);
      end;
  ListPosteriori.Clear;
  ListPriori.Clear;
end;

///////////////////////////////
//    //
///////////////////////////////
procedure TfrmKalmanFilteringDemo.kfNextPrioriEstimation(Sender: TObject; Estimation: Double);
var
  i: integer;
begin
  Series2.Add(Estimation,'',clRed);
  Priori.Caption := FormatFloat('0.00000',Estimation);
  ListPriori.Clear;
  for i := 0 to kf.FilterExponent do
    begin
      ListPriori.Items.Add(FormatFloat('0.0000000', kf.PrioriEstimationItem[i]));
    end;
  ListPriori.Repaint;
end;

////////////////////////////////////
//    //
////////////////////////////////////
procedure TfrmKalmanFilteringDemo.kfNextPosterioriEstimation(Sender: TObject; Estimation: Double);
var
  i: integer;
  xTemp: Extended;
begin
  Series3.Add(Estimation,'',clGreen);
  Posteriori.Caption := FormatFloat('0.0000000',Estimation);
  ListPosteriori.Clear;
  ListPosteriori.Repaint;
  for i:= 0 to kf.FilterExponent do
    begin
      xTemp := kf.PosterioriEstimationItem[i];
      ListPosteriori.Items.Add(FormatFloat('0.0000000',xTemp));
    end;
  ListPosteriori.Repaint;
end;

/////////////////////////////////
//    //
/////////////////////////////////
procedure TfrmKalmanFilteringDemo.kfNextItem(Sender: TObject; Value: Double);
begin
  Series1.Add(Value,'',clBlue);
  Truth.Caption := FormatFloat('0.0000000',Value);
end;

///////////////////////////
//   ""  //
///////////////////////////
procedure TfrmKalmanFilteringDemo.Button3Click(Sender: TObject);
var
  i: integer;
begin
  ClearClick(Clear);
  for i := 0 to  szStreet do
    Button2Click(Button2);
end;

//////////////////////////////////
//   " "  //
//////////////////////////////////
procedure TfrmKalmanFilteringDemo.BtnPolynomialClick(Sender: TObject);
begin
  kf.GoAlongPolynomial;
end;

////////////////////////////////////////
//   "" //
////////////////////////////////////////
procedure TfrmKalmanFilteringDemo.RecursiveClick(Sender: TObject);
begin
  kf.Mode := mdRecursive;
end;

////////////////////////////////////////////
//   " " //
////////////////////////////////////////////
procedure TfrmKalmanFilteringDemo.MovingaverageClick(Sender: TObject);
begin
  kf.Mode := mdMovingAverage;
end;

procedure TfrmKalmanFilteringDemo.Button1Click(Sender: TObject);
begin
  Memo1.Visible := true;
end;

end.
